Cdefine(VAX)
CFor open or close
C location of system-wide "SYMBOLS." file
CMoved from 1 (VAX) to * for compiler who checks(AIX)
Cdefine(DELETEF,'D')
CWas 3 for VMS
Cdefine(EXTEND,'A')
Cdefine(FORTRAN,'F')
C maximum field for integer strings
C must be highest lu for standard files
Cdefine(PRINTF,'P')
Cdefine(READ,'R')
Cdefine(READDELETE,'X')
Cdefine(READONLY,'R')
Cdefine(READWRITE,'W')
Cdefine(SAVEF,'S')
C Was 2 for VAX ?
Cdefine(WRITE,'W')
C definitions for macro processor
C put on a file named 'macsym'
C pushback buffer for ngetch and putbak
C max chars in a definition
C max depth of file inclusion
C max chars in all definitions
C max chars in a token
CModif NB
C number of characters per integer
C-----------------------------------------------------------------------
C definitions for the Ratfiv preprocessor
C put on a file named 'ratsym'
C max space for for reinit clauses
C function name size in dfunct
C max stack depth for parser
C max length of format in read, write, encode,decode
C max number of chars in string declares per module
C max stack for switch statement
C min number of cases to generate branch table
C reciprocal of density neccessary for branch table
C max chars in all definitions
C literal toggle flag
C number base flag
Cio.r Modified by N. Brouard for AIX, FORTRAN 2.0
C September 1991
C
C
C
C    RATLIB utility routines - I/O routines
C    ======================================
C
C
C         Author:  William P. Wood, Jr.
C                  Computer Center
C                  Institute For Cancer Research
C                  7701 Burholme Ave.
C                  Philadelphia, Pa. 19111
C                  (215) 728 2760
C
C         Version: 2.0
C
C         Date:   December 18, 1981
C
C
C
C      *******************************************************
C      *                                                     *
C      *      THIS SOFTWARE WAS DEVELOPED WITH SUPPORT       *
C      *      FROM THE NATIONAL INSTITUTES OF HEALTH:        *
C      *         NIH CA06927                                 *
C      *         NIH CA22780                                 *
C      *                                                     *
C      *      DIRECT INQUIRIES TO:                           *
C      *            COMPUTER CENTER                          *
C      *            THE INSTITUTE FOR CANCER RESEARCH        *
C      *            7701 BURHOLME AVENUE                     *
C      *            PHILADELPHIA, PENNSYLVANIA   19111       *
C      *                                                     *
C      *      NO WARRANTY OR REPRESENTATION, EXPRESS OR      *
C      *      IMPLIED, IS MADE WITH RESPECT TO THE           *
C      *      CORRECTNESS, COMPLETENESS, OR USEFULNESS       *
C      *      OF THIS SOFTWARE, NOR THAT USE OF THIS         *
C      *      SOFTWARE MIGHT NOT INFRINGE PRIVATELY          *
C      *      OWNED RIGHTS.                                  *
C      *                                                     *
C      *      NO LIABILITY IS ASSUMED WITH RESPECT TO        *
C      *      THE USE OF, OR FOR DAMAGES RESULTING FROM      *
C      *      THE USE OF THIS SOFTWARE                       *
C      *                                                     *
C      *******************************************************
C
C acopy - copy  size  lines from  fdi  to  fdo
      SUBROUTINE ACOPY(FDI, FDO, SIZE)
C$   integer fdi, fdo, size
C$   integer*4 ni4, ncop
C$   ni4 = size
C$   call copy(fdi, fdo, ni4, ncop)
C$
      INTEGER GETLIN
      INTEGER BUF(134)
      INTEGER FDI, FDO, I, SIZE
      I = 1
      DO WHILE (I .LE. SIZE)
        IF (GETLIN(BUF, FDI) .EQ. -10) THEN
          GOTO 2020
        END IF
        CALL PUTLIN(BUF, FDO)
2010    I = I + 1
      END DO
2020  CONTINUE
      RETURN
      END
C amove - move  name1  to  name2
      SUBROUTINE AMOVE(NAME1, NAME2)
      INTEGER NAME1(*), NAME2(*)
      INTEGER CREATE, OPEN
      INTEGER FD1, FD2
      FD1 = OPEN(NAME1, 114)
      IF (FD1 .EQ. -1) THEN
        CALL CANT(NAME1)
      END IF
      FD2 = CREATE(NAME2, 119)
      IF (FD2 .EQ. -1) THEN
        CALL CANT(NAME2)
      END IF
      CALL FCOPY(FD1, FD2)
      RETURN
      END
C fcopy - copy file  in  to file  out
      SUBROUTINE FCOPY(IN, OUT)
C$   integer in, out
C$   integer*4 ni4, ncop
C$   data ni4/2 147 483 647/
C$   call copy(in, out, ni4, ncop)
C$
      INTEGER BUF(134)
      INTEGER GETLIN
      INTEGER IN, OUT
2030  DO WHILE (GETLIN(BUF, IN) .NE. -10)
        CALL PUTLIN(BUF, OUT)
      END DO
      RETURN
      END
C initr4 - initialize standard files
      SUBROUTINE INITR4
      COMMON/FCOMR/MXFILE, IOLEN, LASTC, TIIN, ACTUN(6), IOIN(134)
      INTEGER MXFILE
      INTEGER IOLEN
      INTEGER LASTC
      LOGICAL TIIN
      INTEGER ACTUN
      INTEGER IOIN
      COMMON/CARG/ARGSTR(134), UPFLAG, NOREAD
      INTEGER ARGSTR
      LOGICAL UPFLAG, NOREAD
      INTEGER IER, I, NLONG
      INTEGER NAMEIN(45), NAMEOUT(45)
      LASTC = 0
      IOLEN = 0
      DO 2050 I = 1, 6
        ACTUN(I) = 0
2050  CONTINUE
      MXFILE = 6
C fold commands to upper case
      UPFLAG = .TRUE.
C haven't read command line yet
      NOREAD = .TRUE.
C   call errset(28,.true.,.false.,.true.,.false.,15)  # close error
C   call errset(29,.true.,.false.,.true.,.false.,15)  # no such file
C   call errset(30,.true.,.false.,.true.,.false.,15)  # open failure
C   call errset(43,.true.,.false.,.false.,.false.,15) # file name specification
      RETURN
      END
C endr4 - close up shop
      SUBROUTINE ENDR4
C
C stat should be 0-4 to indicate one of the following conditions:
C  0 none,  1 success,  2 warning,  3 error,  4 severe error
C the worst status in successive calls to xitsta is remembered by
C xitsta and an exit with that status done at program termination.
C
      COMMON/STATUS/ISTAT
C   iistat = iistat|2%10000000
      I2070 = (ISTAT)
      GOTO 2070
2090  CONTINUE
        CALL EXIT(0)
C     case 0,1: stop 0;
C	call exit_(0);
C     case 2: stop 'Warning';
C     case 3: stop 'Error';
C     case 4: stop 'Sever error';
C     default: stop 255;
        GOTO 2080
2100  CONTINUE
        CALL EXIT(1)
        GOTO 2080
2070  CONTINUE
      IF (I2070 .EQ. 0) GOTO 2090
      IF (I2070 .EQ. 1) GOTO 2090
      GOTO 2100
2080  CONTINUE
      END
Cmodifmr
C create - open a new file
      INTEGER FUNCTION CREATE(NAME, STAT)
      INTEGER NAME(*)
      INTEGER OPEN
      INTEGER STAT
      CREATE = OPEN(NAME, STAT)
      IF (CREATE .EQ. -1) THEN
        CALL PUTLIN(NAME, 0)
        CALL REMARK(': can''t create.')
      END IF
      RETURN
      END
C remove - delete a file
      INTEGER FUNCTION REMOVE(FILE)
      INTEGER FILE(*)
      INTEGER OPEN, CLOSEL
      REMOVE = OPEN(FILE, 120)
      IF (REMOVE .NE. -1) THEN
        REMOVE = CLOSEL(REMOVE, 100)
      END IF
      RETURN
      END
C openc - open a file, print can't message if error
      INTEGER FUNCTION OPESNC(NAME, STAT)
      INTEGER NAME(*), STAT
      INTEGER OPEN
      OPENC = OPEN(NAME, STAT)
      IF (OPENC .EQ. -1) THEN
        CALL PUTLIN(NAME, 0)
        CALL REMARK(': can''t open.')
      END IF
      RETURN
      END
C open - open a file
      INTEGER FUNCTION OPEN(NAME, STAT)
      INTEGER NAME(*), STAT, BUF(230)
      INTEGER IER, CONCAT
      COMMON/FCOMR/MXFILE, IOLEN, LASTC, TIIN, ACTUN(6), IOIN(134)
      INTEGER MXFILE
      INTEGER IOLEN
      INTEGER LASTC
      LOGICAL TIIN
      INTEGER ACTUN
      INTEGER IOIN
      BUF(1) = 0
      LASTC = CONCAT(BUF, NAME, 230)
      DO 2110 I = 1, MXFILE
        IF (ACTUN(I) .NE. 0) THEN
          GOTO 2110
        END IF
        CALL OPN(I + 6, BUF, STAT, IER)
        IF (IER.NE.0) THEN
          OPEN =  - 1
        ELSE
          OPEN = I + 6
          ACTUN(I) = STAT
        END IF
        RETURN
2110  CONTINUE
      CALL REMARK('too many files opened.')
      OPEN =  - 1
      RETURN
      END
C closec - close a file, print message if error
      INTEGER FUNCTION CLOSEC(F, STAT)
      INTEGER STAT
      INTEGER F, CLOSEL
      CLOSEC = CLOSEL(F, STAT)
      IF (CLOSEC .EQ. -1) THEN
        CALL REMARK('error closing file.')
      END IF
      RETURN
      END
C close - close a file
      SUBROUTINE CLOSE(F)
      INTEGER F, CLOSEL, I
      I = CLOSEL(F, 115)
      RETURN
      END
C closel - close a file
      INTEGER FUNCTION CLOSEL(IUNIT, STAT)
      COMMON/FCOMR/MXFILE, IOLEN, LASTC, TIIN, ACTUN(6), IOIN(134)
      INTEGER MXFILE
      INTEGER IOLEN
      INTEGER LASTC
      LOGICAL TIIN
      INTEGER ACTUN
      INTEGER IOIN
      INTEGER IUNIT
      INTEGER STAT
C Modif NB Jan 96
C%	  CHARACTER STAT
C%         stat=char(statf)
      CLOSEL =  - 1
      IF (IUNIT .GT. 6) THEN
        IF (ACTUN(IUNIT-6) .EQ. 0) THEN
          CLOSEL = 1
          RETURN
        END IF
      END IF
      IF (STAT .EQ. 115) THEN
        CLOSE(UNIT = IUNIT, STATUS = 'KEEP', ERR = 99)
      ELSE IF (STAT .EQ. 100) THEN
        CLOSE(UNIT = IUNIT, STATUS = 'DELETE', ERR = 999)
      ELSE IF (STAT .EQ. 112) THEN
        CLOSE(UNIT = IUNIT, STATUS = 'KEEP', ERR = 999)
        CALL REMARK('Fortran cannot PRINT  in closel.')
      ELSE
        CALL REMARK('illegal command in closel.')
        RETURN
      END IF
      IF (IUNIT .GT. 6) THEN
        ACTUN(IUNIT - 6) = 0
      END IF
      CLOSEL = 1
99    CONTINUE
      RETURN
999   CONTINUE
      CLOSE(UNIT = IUNIT, STATUS = 'KEEP', ERR = 99)
      IF (IUNIT .GT. 6) THEN
        ACTUN(IUNIT - 6) = 0
      END IF
      RETURN
      END
C cant - print can't open file message and stop
C<wpw>
      SUBROUTINE CANT(BUF)
      INTEGER BUF(*)
      CALL PUTLIN(BUF, 0)
      CALL ERROR(': can''t open.')
      END
C error - print fatal error message, then die
      SUBROUTINE ERROR(BUF)
      INTEGER BUF(*)
      CALL XITSTA(4)
      IF (BUF(1) .NE. 0) THEN
        CALL REMARK(BUF)
      END IF
      CALL ENDR4
      RETURN
      END
C outlin - output a line
      SUBROUTINE OUTLIN(BUF, F)
      INTEGER BUF(*)
      INTEGER C
      INTEGER F
      CALL PUTLIN(BUF, F)
CModif NB sep-91
      C = 10
      CALL PUTCH(C, F)
      RETURN
      END
C remark - print message; assure NEWLINE
      SUBROUTINE REMARK(LINE)
      INTEGER LINE(*)
      INTEGER I
      INTEGER C
      I = 1
      DO WHILE (LINE(I) .NE. 0)
        IF (LINE(I) .EQ. 46 .AND. LINE(I+1) .EQ. 0) THEN
          GOTO 2150
        END IF
        CALL PUTCH(LINE(I), 0)
2140    I = I + 1
      END DO
2150  CONTINUE
      IF (I .EQ. 1) THEN
CModif type NB -sep-91
        C = 10
        CALL PUTCH(C, 0)
      ELSE IF (LINE(I-1) .NE. 10) THEN
        C = 10
        CALL PUTCH(C, 0)
      END IF
      RETURN
      END
C$# getlin - get a line from a file
C$   integer function getlin(inbuf, in)
C$   include iocom.rat
C$   character inbuf(ARB)
C$   integer in, getrec
C$   if (lastc < iolen) {  # still some chars in ioin
C$      getlin = 0
C$      repeat {
C$         lastc = lastc+1
C$         getlin = getlin+1
C$         inbuf(getlin) = ioin(lastc)
C$         } until (lastc == iolen)
C$      inbuf(getlin+1) = EOS
C$      }
C$   else
C$      getlin = getrec(inbuf, in)
C$   return
C$   end
C$
C getlin - get a line from a file
      INTEGER FUNCTION GETLIN(BUF, IN)
      INTEGER BUF(134)
      INTEGER C, GETCH
      INTEGER IN, I
      I = 0
2160  CONTINUE
        I = I + 1
        BUF(I) = GETCH(C, IN)
2170  IF (.NOT.(BUF(I) .EQ. 10 .OR. BUF(I) .EQ. -10)) GOTO 2160
      IF (BUF(I) .EQ. -10) THEN
        GETLIN =  - 10
      ELSE
        GETLIN = I
      END IF
      IF (I .GE. 134) THEN
        CALL ERROR('buffer overflow in getlin.')
      ELSE
        BUF(I + 1) = 0
      END IF
      RETURN
      END
C$# getch - get characters from file
C$   character function getch(c, f)
C$   include iocom.rat
C$   character c
C$   integer f, getrec
C$   if (lastc >= iolen) {
C$      iolen = getrec(ioin, f)
C$      lastc = 0
C$      if (iolen < 1) {
C$         c = EOF
C$         getch = EOF
C$         return
C$         }
C$      }
C$   lastc = lastc + 1
C$   c = ioin(lastc)
C$   getch = c
C$   return
C$   end
C$
C getch - get characters from file
C
C
C
C getch - get characteres
      INTEGER FUNCTION GETCH(C, F)
      INTEGER F, ISTAT, LASTC
C modif MR 23-AUG-84
      INTEGER BUFFER(134, 15), C
      CHARACTER*134BUF2
      INTEGER BUF(134)
C   equivalence(buf,buf2)
CMAXFILE +PRINTER
      INTEGER DERNIERS(15), I
      DATA DERNIERS/15*0/
      LASTC = DERNIERS(F + 1)
C
      IF (LASTC.EQ.0) THEN
        READ(F, 1, IOSTAT=ISTAT) BUF2
1       FORMAT(A)
        IF (ISTAT .NE. 0) THEN
          GOTO 10
        END IF
        DO 2190 NC = LEN(BUF2), 1,  - 1
          BUF(NC) = ICHAR(BUF2(NC:NC))
2190    CONTINUE
        DO 2210 NC = LEN(BUF2), 1,  - 1
          IF (BUF2(NC:NC) .NE. ' ') THEN
            GOTO 2
          END IF
2210    CONTINUE
2       CONTINUE
        IF ((NC .EQ. 1) .AND. BUF2(NC:NC) .EQ. ' ') THEN
          NC = 0
          BUFFER(NC + 1, F + 1) = 10
        ELSE
          BUFFER(NC + 1, F + 1) = 10
          DO 2230 I = 1, NC
            BUFFER(I, F + 1) = BUF(I)
2230      CONTINUE
        END IF
      END IF
      LASTC = LASTC + 1
      C = BUFFER(LASTC, F + 1)
      IF (BUFFER(LASTC, F+1) .EQ. 10) THEN
        LASTC = 0
      END IF
      DERNIERS(F + 1) = LASTC
      GETCH = C
      RETURN
10    GETCH =  - 10
      C =  - 10
      RETURN
      END
C
C
C
C putch - put characteres
      SUBROUTINE PUTCH(C, F)
      INTEGER F, ISTAT, LASTC
C modif MR 23-AUG-84
C modif NB 6-sep-1991
      INTEGER BUFFER(8, 134), C
      CHARACTER*134BUFCHAR
      INTEGER DERNIERS(8)
C   data derniers /8*0/
      COMMON/BUFCOM/BUFFER, DERNIERS
      LASTC = DERNIERS(F + 1)
      IF (LASTC .GE. 132 .OR. C .EQ. 10) THEN
        DO 2250 IND = 1, LASTC
          BUFCHAR(IND:IND) = CHAR(BUFFER(F + 1, IND))
C     write(f,1) (buffer(f+1,ind),ind=1,lastc)
2250    CONTINUE
        WRITE(F, 1) (BUFCHAR(1:LASTC))
1       FORMAT(A)
        LASTC = 0
        DERNIERS(F + 1) = LASTC
        IF (C .EQ. 10) THEN
          RETURN
        END IF
      END IF
      LASTC = LASTC + 1
      BUFFER(F + 1, LASTC) = C
      DERNIERS(F + 1) = LASTC
      RETURN
      END
C
C
C putlin - put out line by repeated calls to putch
      SUBROUTINE PUTLIN(B, F)
      INTEGER B(*)
      INTEGER F, I
      I = 1
      DO WHILE (B(I) .NE. 0)
        CALL PUTCH(B(I), F)
2280    I = I + 1
      END DO
      RETURN
      END
C$# fskip - skip  n  lines on file  fd
C$   subroutine fskip(fd, n)
C$   integer fd, n
C$   integer*4 i4, ir4
C$   i4 = n
C$   call skip(fd, i4, ir4)
C$   return
C$   end
C$
C fskip - skip  n  lines on file  fd
      SUBROUTINE FSKIP(FD, N)
      INTEGER SKPLIN
      INTEGER FD, I, N
      I = 1
      DO WHILE (I .LE. N)
        IF (SKPLIN(FD) .EQ. -10) THEN
          GOTO 2320
        END IF
2310    I = I + 1
      END DO
2320  CONTINUE
      RETURN
      END
C fsize - size of file in lines
C$   integer function fsize(fd)
C$   integer fd
C$   integer*4 i4, ir4
C$   data i4/2 147 483 647/
C$   call skip(fd, i4, ir4)
C$   if (ir4 > MAXINT) call error('file too big.')
C$   fsize = ir4
C$   rewind fd
C$   return
C$
C fsize - size of file in lines
      INTEGER FUNCTION FSIZE(FD)
      INTEGER SKPLIN
      INTEGER FD
      FSIZE = 0
      DO WHILE (SKPLIN(FD) .NE. -10)
2340    FSIZE = FSIZE + 1
      END DO
      REWIND FD
      RETURN
      END
C skplin - skip a line in a file
      INTEGER FUNCTION SKPLIN(F)
      INTEGER F
      READ(F, 1, END=99, ERR=99) 
1     FORMAT()
      SKPLIN = 0
      RETURN
99    SKPLIN =  - 10
      RETURN
      END
C$# prompt - prompt for input from STDIN
C$   subroutine prompt(buf)
C$   include iocom.rat
C$   character buf(ARB)
C$   if (!tiin) return	# return if STDIN is not pointing at the terminal
C$   call putch(DOLLAR, STDIN)
C$   call putlin(buf, STDIN)
C$   call putch(NEWLINE, STDIN)
C$   return
C prompt - output a prompt to ERROUT
      SUBROUTINE PROMPT(STR)
      INTEGER STR(*)
      INTEGER I, LENGTH
      WRITE(0, 1) (STR(I), I = 1, LENGTH(STR))
1     FORMAT('$', 132A1)
      RETURN
      END
C$   end
C inmap - convert left-adjusted ascii to right-adjusted ascii #<wpw>
      INTEGER FUNCTION INMAP(CHAR)
      INTEGER CHAR, ICHIN
      INTEGER LCH(2)
      EQUIVALENCE(ICHIN, LCH(1))
      ICHIN = CHAR
      LCH(2) = 0
      INMAP = ICHIN
      RETURN
      END
C outmap - convert right-adjusted ascii to left-adjusted ascii  #<wpw>
      INTEGER FUNCTION OUTMAP(CHAR)
      INTEGER CHAR
      OUTMAP = CHAR
      RETURN
      END
C usrbin - get name of /usr/bin (major tools utility directory)
C           CHANGE FOR EACH SYSTEM
      SUBROUTINE USRBIN(NAME)
      INTEGER NAME(*)
C Insert the name of the directory where all the tools are kept
      CALL SCOPY('/usr/local/include/', 1, NAME, 1)
      RETURN
      END
