Cdefine(VAX)
CFor open or close
C location of system-wide "SYMBOLS." file
CMoved from 1 (VAX) to * for compiler who checks(AIX)
Cdefine(DELETEF,'D')
CWas 3 for VMS
Cdefine(EXTEND,'A')
Cdefine(FORTRAN,'F')
C maximum field for integer strings
C must be highest lu for standard files
Cdefine(PRINTF,'P')
Cdefine(READ,'R')
Cdefine(READDELETE,'X')
Cdefine(READONLY,'R')
Cdefine(READWRITE,'W')
Cdefine(SAVEF,'S')
C Was 2 for VAX ?
Cdefine(WRITE,'W')
C definitions for macro processor
C put on a file named 'macsym'
C pushback buffer for ngetch and putbak
C max chars in a definition
C max depth of file inclusion
C max chars in all definitions
C max chars in a token
CModif NB
C number of characters per integer
C-----------------------------------------------------------------------
C definitions for the Ratfiv preprocessor
C put on a file named 'ratsym'
C max space for for reinit clauses
C function name size in dfunct
C max stack depth for parser
C max length of format in read, write, encode,decode
C max number of chars in string declares per module
C max stack for switch statement
C min number of cases to generate branch table
C reciprocal of density neccessary for branch table
C max chars in all definitions
C literal toggle flag
C number base flag
C
C
C
C    RATLIB utility routines - miscellaneous support for all programs
C    ================================================================
C
C
C         Author:  William P. Wood, Jr.
C                  Computer Center
C                  Institute For Cancer Research
C                  7701 Burholme Ave.
C                  Philadelphia, Pa. 19111
C                  (215) 728 2760
C
C         Version: 2.0
C
C         Date:   December 18, 1981
C
C
C
C      *******************************************************
C      *                                                     *
C      *      THIS SOFTWARE WAS DEVELOPED WITH SUPPORT       *
C      *      FROM THE NATIONAL INSTITUTES OF HEALTH:        *
C      *         NIH CA06927                                 *
C      *         NIH CA22780                                 *
C      *                                                     *
C      *      DIRECT INQUIRIES TO:                           *
C      *            COMPUTER CENTER                          *
C      *            THE INSTITUTE FOR CANCER RESEARCH        *
C      *            7701 BURHOLME AVENUE                     *
C      *            PHILADELPHIA, PENNSYLVANIA   19111       *
C      *                                                     *
C      *      NO WARRANTY OR REPRESENTATION, EXPRESS OR      *
C      *      IMPLIED, IS MADE WITH RESPECT TO THE           *
C      *      CORRECTNESS, COMPLETENESS, OR USEFULNESS       *
C      *      OF THIS SOFTWARE, NOR THAT USE OF THIS         *
C      *      SOFTWARE MIGHT NOT INFRINGE PRIVATELY          *
C      *      OWNED RIGHTS.                                  *
C      *                                                     *
C      *      NO LIABILITY IS ASSUMED WITH RESPECT TO        *
C      *      THE USE OF, OR FOR DAMAGES RESULTING FROM      *
C      *      THE USE OF THIS SOFTWARE                       *
C      *                                                     *
C      *******************************************************
C
C alldig - return YES if str is all digits
      INTEGER FUNCTION ALLDIG(STR)
      INTEGER I
      INTEGER STR(*)
      ALLDIG = 0
      IF (STR(1) .EQ. 0) THEN
        RETURN
      END IF
      I = 1
      DO WHILE (STR(I) .NE. 0)
        IF (STR(I) .LT. 48 .OR. STR(I) .GT. 57) THEN
          RETURN
        END IF
2010    I = I + 1
      END DO
      ALLDIG = 1
      RETURN
      END
C ctoi - convert string at in(i) to integer, increment i
      INTEGER FUNCTION CTOI(IN, I)
      INTEGER IN(*)
      INTEGER INDEXX
      INTEGER D, I
      LOGICAL NEG
      INTEGER DIGITS(11)
      DATA DIGITS(1)/48/,DIGITS(2)/49/,DIGITS(3)/50/,DIGITS(4)/51/,DIGIT
     *S(5)/52/,DIGITS(6)/53/,DIGITS(7)/54/,DIGITS(8)/55/,DIGITS(9)/56/,D
     *IGITS(10)/57/,DIGITS(11)/0/
2030  DO WHILE (IN(I) .EQ. 32 .OR. IN(I) .EQ. 9)
        I = I + 1
      END DO
      IF (IN(I) .EQ. 45) THEN
        NEG = .TRUE.
        I = I + 1
      ELSE
        NEG = .FALSE.
      END IF
      CTOI = 0
      DO WHILE (IN(I) .NE. 0)
        D = INDEXX(DIGITS, IN(I))
        IF (D .EQ. 0) THEN
C non-digit
          GOTO 2070
        END IF
        CTOI = 10*CTOI + D - 1
2060    I = I + 1
      END DO
2070  CONTINUE
      IF (NEG) THEN
        CTOI =  - CTOI
      END IF
      RETURN
      END
C concat - concatenate two strings
      INTEGER FUNCTION CONCAT(S1, S2, LIM)
      INTEGER S1(*), S2(*)
      INTEGER LIM, I, LENGTH, L
      L = LENGTH(S1)
      I = L + 1
      DO WHILE (I .LT. LIM .AND. S2(I-L) .NE. 0)
        S1(I) = S2(I - L)
2090    I = I + 1
      END DO
      S1(I) = 0
      CONCAT = I - 1
      RETURN
      END
C equal - compare str1 to str2; return YES if equal, NO if not
      INTEGER FUNCTION EQUAL(STR1, STR2)
      INTEGER STR1(*), STR2(*)
      INTEGER I
      I = 1
      DO WHILE (STR1(I) .EQ. STR2(I))
        IF (STR1(I) .EQ. 0) THEN
          EQUAL = 1
          RETURN
        END IF
2120    I = I + 1
      END DO
      EQUAL = 0
      RETURN
      END
C getwrd - get non-blank word from in(i) into  out, increment i
      INTEGER FUNCTION GETWRD(IN, I, OUT)
      INTEGER IN(*), OUT(*)
      INTEGER I, J
2140  DO WHILE (IN(I) .EQ. 32 .OR. IN(I) .EQ. 9)
        I = I + 1
      END DO
      J = 1
2160  DO WHILE (IN(I) .NE. 0 .AND. IN(I) .NE. 32 .AND. IN(I) .NE. 9 .AND
     *. IN(I) .NE. 10)
        OUT(J) = IN(I)
        I = I + 1
        J = J + 1
      END DO
      OUT(J) = 0
      GETWRD = J - 1
      RETURN
      END
C index - find character  c  in string  str
      INTEGER FUNCTION INDEXX(STR, C)
      INTEGER C, STR(*)
      INDEXX = 1
      DO WHILE (STR(INDEXX) .NE. 0)
        IF (STR(INDEXX) .EQ. C) THEN
          RETURN
        END IF
2190    INDEXX = INDEXX + 1
      END DO
      INDEXX = 0
      RETURN
      END
C itoc - convert integer  int  to char string in  str
      INTEGER FUNCTION ITOC(INT, STR, SIZE)
      INTEGER IABS, MOD
      INTEGER D, I, INT, INTVAL, J, K, SIZE
      INTEGER STR(*)
      INTEGER DIGITS(11)
      DATA DIGITS(1)/48/,DIGITS(2)/49/,DIGITS(3)/50/,DIGITS(4)/51/,DIGIT
     *S(5)/52/,DIGITS(6)/53/,DIGITS(7)/54/,DIGITS(8)/55/,DIGITS(9)/56/,D
     *IGITS(10)/57/,DIGITS(11)/0/
      INTVAL = INT
      STR(1) = 0
      I = 1
2210  CONTINUE
C generate digits
        I = I + 1
        D = MOD(INTVAL, 10)
        STR(I) = DIGITS(IABS(D) + 1)
        INTVAL = (INTVAL - D)/10
2220  IF (.NOT.(INTVAL .EQ. 0 .OR. I .GE. SIZE)) GOTO 2210
      IF (INT .LT. 0 .AND. I .LT. SIZE) THEN
C then sign
        I = I + 1
        STR(I) = 45
      END IF
      ITOC = I - 1
      J = 1
      DO WHILE (J .LT. I)
C then reverse
        K = STR(I)
        STR(I) = STR(J)
        STR(J) = K
        I = I - 1
2250    J = J + 1
      END DO
      RETURN
      END
C itocrj - convert integer to character in a right-adjusted field
      INTEGER FUNCTION ITOCRJ(INT, STR, SIZE)
      INTEGER INT, SIZE, J
      INTEGER ITOC
      INTEGER STR(*), TBUF(7)
      J = ITOC(INT, TBUF, 7)
      I = SIZE - 1
      DO WHILE (J .GT. 0 .AND. I .GT. 0)
        STR(I) = TBUF(J)
        J = J - 1
2280    I = I - 1
      END DO
      DO WHILE (I .GT. 0)
        STR(I) = 32
2310    I = I - 1
      END DO
      STR(SIZE) = 0
      ITOCRJ = SIZE - 1
      RETURN
      END
C length - compute length of string
      INTEGER FUNCTION LENGTH(STR)
      INTEGER STR(*)
      LENGTH = 0
      DO WHILE (STR(LENGTH+1) .NE. 0)
2340    LENGTH = LENGTH + 1
      END DO
      RETURN
      END
C putnum - put integer
      SUBROUTINE PUTNUM(INT, F)
      INTEGER INT, F, I, N
      INTEGER CHARS(7)
      INTEGER ITOC
      N = ITOC(INT, CHARS, 7)
      I = 1
      DO WHILE (I .LE. N)
        CALL PUTCH(CHARS(I), F)
2370    I = I + 1
      END DO
      RETURN
      END
C putdec - put decimal integer  n  in field width >= w
      SUBROUTINE PUTDEC(N, W, F)
      INTEGER CHARS(7)
CModif NB
      INTEGER CC
      INTEGER ITOC
      INTEGER I, N, ND, W, F
      ND = ITOC(N, CHARS, 7)
      I = ND + 1
      DO WHILE (I .LE. W)
        CC = 32
        CALL PUTCH(CC, F)
2400    I = I + 1
      END DO
      I = 1
      DO WHILE (I .LE. ND)
        CALL PUTCH(CHARS(I), F)
2430    I = I + 1
      END DO
      RETURN
      END
C scopy - copy string at from(i) to to(j)
      SUBROUTINE SCOPY(FROM, I, TO, J)
      INTEGER FROM(*), TO(*)
      INTEGER I, J, K1, K2
      K2 = J
      K1 = I
      DO WHILE (FROM(K1) .NE. 0)
        TO(K2) = FROM(K1)
        K2 = K2 + 1
2460    K1 = K1 + 1
      END DO
      TO(K2) = 0
      RETURN
      END
C type - determine type of character
      INTEGER FUNCTION TYPE(C)
      INTEGER C
      INTEGER CTYPE(256)
C A-Z and a-z are alphabetic;
C 0-9 are digits;
      DATA CTYPE/128*0, 48*0, 10*2, 7*0, 26*3, 6*0, 26*3, 5*0/
C$   type = ctype(c+129)
C$   if (type == 0) type = c
      IF (C .GE. 48 .AND. C .LE. 57) THEN
        TYPE = 2
      ELSE IF (C .GE. 97 .AND. C .LE. 122) THEN
        TYPE = 3
      ELSE IF (C .GE. 65 .AND. C .LE. 90) THEN
        TYPE = 3
      ELSE
        TYPE = C
      END IF
      RETURN
      END
C fold - fold all letters to lower case
      SUBROUTINE FOLD(TOKEN)
      INTEGER TOKEN(*)
      INTEGER I
      I = 1
      DO WHILE (TOKEN(I) .NE. 0)
        IF (TOKEN(I) .GE. 65 .AND. TOKEN(I) .LE. 90) THEN
          TOKEN(I) = TOKEN(I) - 65 + 97
        END IF
2490    I = I + 1
      END DO
      RETURN
      END
C clower - change letter to lower case
      INTEGER FUNCTION CLOWER(C)
      INTEGER C
      IF (C .GE. 65 .AND. C .LE. 90) THEN
        CLOWER = C - 65 + 97
      ELSE
        CLOWER = C
      END IF
      RETURN
      END
C cupper - change letter to upper case
      INTEGER FUNCTION CUPPER(C)
      INTEGER C
      IF (C .GE. 97 .AND. C .LE. 122) THEN
        CUPPER = C - 97 + 65
      ELSE
        CUPPER = C
      END IF
      RETURN
      END
C lower - fold all alphas to lower case
      SUBROUTINE LOWER(TOKEN)
      INTEGER TOKEN(*)
      INTEGER I
      I = 1
      DO WHILE (TOKEN(I) .NE. 0)
        IF (TOKEN(I) .GE. 65 .AND. TOKEN(I) .LE. 90) THEN
          TOKEN(I) = TOKEN(I) - 65 + 97
        END IF
2520    I = I + 1
      END DO
      RETURN
      END
C upper - fold all alphas to upper case
      SUBROUTINE UPPER(TOKEN)
      INTEGER TOKEN(*)
      INTEGER I
      I = 1
      DO WHILE (TOKEN(I) .NE. 0)
        IF (TOKEN(I) .GE. 97 .AND. TOKEN(I) .LE. 122) THEN
          TOKEN(I) = TOKEN(I) - 97 + 65
        END IF
2550    I = I + 1
      END DO
      RETURN
      END
C uniqm - find command string which matches input string uniquely
      SUBROUTINE UNIQM(IN, CMDSTR, CODE, RESULT)
      INTEGER IN(*), CMDSTR(*)
      INTEGER CODE, RESULT, I
      IF (IN(1) .EQ. 0 .AND. CMDSTR(1) .NE. 0) THEN
Cnull string must match exactly
        RETURN
      END IF
      I = 1
      DO WHILE (IN(I) .NE. 0)
        IF (IN(I) .NE. CMDSTR(I)) THEN
          RETURN
        END IF
2580    I = I + 1
      END DO
      IF (RESULT .NE. 0) THEN
        RESULT =  - 1
      ELSE IF (CODE .GE. 0) THEN
        RESULT = CODE
      ELSE IF (CMDSTR(I) .EQ. 0) THEN
C if code neg., must match exactly
        RESULT =  - CODE
      END IF
      RETURN
      END
C pmatch - return YES if str1 is a partial match to str2
      INTEGER FUNCTION PMATCH(STR1, STR2)
      INTEGER STR1(*), STR2(*)
      INTEGER C
      C = 0
      CALL UNIQM(STR1, STR2, 1, C)
      IF (C .EQ. 0) THEN
        PMATCH = 0
      ELSE
        PMATCH = 1
      END IF
      RETURN
      END
C search - find a pattern in a line
      INTEGER FUNCTION SEARCH(TEXT, PATTRN)
      INTEGER TEXT(*), PATTRN(*)
      INTEGER N, M, J, LENGTH, I
      SEARCH = 0
      M = LENGTH(PATTRN)
      IF (M .EQ. 0) THEN
        RETURN
      END IF
      N = LENGTH(TEXT)
      J = M
2600  DO WHILE (J .LE. N)
        DO 2620 I = M, 1,  - 1
          IF (TEXT(J-M+I) .NE. PATTRN(I)) THEN
            J = J + 1
            GOTO 2600
          END IF
2620    CONTINUE
        SEARCH = J - M + 1
        RETURN
      END DO
      RETURN
      END
C-h- conc           191 asc  3-oct-80 11:28:26
      SUBROUTINE CONC(FIRST, SECOND, OUT)
C Modif byte into character january 96 ?
      INTEGER FIRST(*), SECOND(*), OUT(*)
      INTEGER I
      I = 1
      CALL STCOPY(FIRST, 1, OUT, I)
      CALL STCOPY(SECOND, 1, OUT, I)
      RETURN
      END
C-h- stcopy           201 asc  3-oct-80 11:28:26
      SUBROUTINE STCOPY(IN, I, OUT, J)
      INTEGER IN(*), OUT(*)
      INTEGER I, J, K
      K = I
      DO WHILE (IN(K) .NE. 0)
        OUT(J) = IN(K)
        J = J + 1
2650    K = K + 1
      END DO
      OUT(J) = 0
      RETURN
      END
Cmodifmr
C bkscan - return index of first break char in str
      INTEGER FUNCTION BKSCAN(STR, BRK, I)
      INTEGER STR(*), BRK(*)
      INTEGER INDEXX, I
      BKSCAN = I
      DO WHILE (STR(BKSCAN) .NE. 0)
        IF (INDEXX(BRK, STR(BKSCAN)) .NE. 0) THEN
          GOTO 2690
        END IF
2680    BKSCAN = BKSCAN + 1
      END DO
2690  CONTINUE
      RETURN
      END
C scan - return index of first char in str which isn't in scstr
      INTEGER FUNCTION SCAN(STR, SCSTR, I)
      INTEGER STR(*), SCSTR(*)
      INTEGER INDEXX, I
      SCAN = I
      DO WHILE (STR(SCAN) .NE. 0)
        IF (INDEXX(SCSTR, STR(SCAN)) .EQ. 0) THEN
          GOTO 2720
        END IF
2710    SCAN = SCAN + 1
      END DO
2720  CONTINUE
      RETURN
      END
C eq - compare str1 to str2; return .true. if equal, .false. if not
      LOGICAL FUNCTION EQ(STR1, STR2)
      INTEGER STR1(*), STR2(*)
      INTEGER I
      I = 1
      DO WHILE (STR1(I) .EQ. STR2(I))
        IF (STR1(I) .EQ. 0) THEN
          EQ = (.TRUE.)
          RETURN
        END IF
2740    I = I + 1
      END DO
      EQ = (.FALSE.)
      RETURN
      END
C indexq - find character c in string str, ignoring chars within quoted strings
      INTEGER FUNCTION INDEXQ(STR, C)
      INTEGER C, STR(*)
      INTEGER NUQCP
      INDEXQ = NUQCP(STR, 1)
      DO WHILE (STR(INDEXQ) .NE. 0)
        IF (STR(INDEXQ) .EQ. C) THEN
          RETURN
        END IF
2770    INDEXQ = NUQCP(STR, INDEXQ + 1)
      END DO
      INDEXQ = 0
      RETURN
      END
C bkscnq - return index of first break char in str, ignore chars inside quotes
      INTEGER FUNCTION BKSCNQ(STR, BRK, I)
      INTEGER STR(*), BRK(*)
      INTEGER INDEXX, NUQCP, I
      BKSCNQ = NUQCP(STR, I)
      DO WHILE (STR(BKSCNQ) .NE. 0)
        IF (INDEXX(BRK, STR(BKSCNQ)) .NE. 0) THEN
          GOTO 2810
        END IF
2800    BKSCNQ = NUQCP(STR, BKSCNQ + 1)
      END DO
2810  CONTINUE
      RETURN
      END
C nuqcp - return postion of next char which isn't part of a quoted (") string
      INTEGER FUNCTION NUQCP(BUF, I)
      INTEGER BUF(*)
      INTEGER I
      IF (BUF(I) .NE. 34) THEN
        NUQCP = (I)
        RETURN
      END IF
      NUQCP = I + 1
      DO WHILE (BUF(NUQCP) .NE. 0)
        IF (BUF(NUQCP) .EQ. 34) THEN
          NUQCP = NUQCP + 1
          IF (BUF(NUQCP) .NE. 34) THEN
            RETURN
          END IF
        END IF
2830    NUQCP = NUQCP + 1
      END DO
      RETURN
      END
